from __future__ import annotations  # TODO: Remove if python requirement is >= 3.10

from typing import Optional  # , Union, List


from flaschengeist.models import ModelSerializeMixin, Serial
from flaschengeist.database import db

#########
# Types #
#########

_table_prefix_ = "pricelist_old_"


class Price(db.Model, ModelSerializeMixin):
    __allow_unmapped__ = True
    __tablename__ = _table_prefix_ + "pricelist"
    id: int = db.Column(Serial, primary_key=True)
    name: str = db.Column(db.String(30), nullable=False, unique=True)
    price: float = db.Column(db.Numeric(precision=5, scale=2, asdecimal=False), nullable=False)
    price_big: Optional[float] = db.Column(db.Numeric(precision=5, scale=2, asdecimal=False))
    price_club: Optional[float] = db.Column(db.Numeric(precision=5, scale=2, asdecimal=False))
    price_big_club: Optional[float] = db.Column(db.Numeric(precision=5, scale=2, asdecimal=False))
    premium: Optional[float] = db.Column(db.Numeric(precision=5, scale=2, asdecimal=False))
    premium_big: Optional[float] = db.Column(db.Numeric(precision=5, scale=2, asdecimal=False))
    price_extern_club: Optional[float] = db.Column(db.Numeric(precision=5, scale=2, asdecimal=False))
    _drink_type_id = db.Column("drink_type_id", Serial, db.ForeignKey(f"{_table_prefix_}drink_type.id"), nullable=False)
    drink_type: DrinkType = db.relationship("DrinkType")


class DrinkType(db.Model, ModelSerializeMixin):
    __allow_unmapped__ = True
    __tablename__ = _table_prefix_ + "drink_type"
    id: int = db.Column(Serial, primary_key=True)
    name: str = db.Column(db.String(30), nullable=False, unique=True)
